<?php

namespace Featured\Featured\Policies;

use Litepie\User\Contracts\UserPolicy;
use Featured\Featured\Models\1;

class 1Policy
{

    /**
     * Determine if the given user can view the 1.
     *
     * @param UserPolicy $user
     * @param 1 $1
     *
     * @return bool
     */
    public function view(UserPolicy $user, 1 $1)
    {
        if ($user->canDo('featured.1.view') && $user->isAdmin()) {
            return true;
        }

        return $1->user_id == user_id() && $1->user_type == user_type();
    }

    /**
     * Determine if the given user can create a 1.
     *
     * @param UserPolicy $user
     * @param 1 $1
     *
     * @return bool
     */
    public function create(UserPolicy $user)
    {
        return  $user->canDo('featured.1.create');
    }

    /**
     * Determine if the given user can update the given 1.
     *
     * @param UserPolicy $user
     * @param 1 $1
     *
     * @return bool
     */
    public function update(UserPolicy $user, 1 $1)
    {
        if ($user->canDo('featured.1.edit') && $user->isAdmin()) {
            return true;
        }

        return $1->user_id == user_id() && $1->user_type == user_type();
    }

    /**
     * Determine if the given user can delete the given 1.
     *
     * @param UserPolicy $user
     * @param 1 $1
     *
     * @return bool
     */
    public function destroy(UserPolicy $user, 1 $1)
    {
        return $1->user_id == user_id() && $1->user_type == user_type();
    }

    /**
     * Determine if the given user can verify the given 1.
     *
     * @param UserPolicy $user
     * @param 1 $1
     *
     * @return bool
     */
    public function verify(UserPolicy $user, 1 $1)
    {
        if ($user->canDo('featured.1.verify')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given 1.
     *
     * @param UserPolicy $user
     * @param 1 $1
     *
     * @return bool
     */
    public function approve(UserPolicy $user, 1 $1)
    {
        if ($user->canDo('featured.1.approve')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the user can perform a given action ve.
     *
     * @param [type] $user    [description]
     * @param [type] $ability [description]
     *
     * @return [type] [description]
     */
    public function before($user, $ability)
    {
        if ($user->isSuperuser()) {
            return true;
        }
    }
}
